VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Private Sub CommandButton1_Click()                                              '1
 
Dim vi       As Long                                                            '3
Dim ret      As Long
Dim msg      As String
Dim err_msg  As String * 256                                                    '6
 
'Starting the session *******************************************
ret = age5270_init("GPIB::17::INSTR", VI_TRUE, VI_TRUE, vi)                     '9
If ((vi = VI_NULL) Or (ret < VI_SUCCESS)) Then                                 '10
  msg = "Initialization failure." & Chr(10) & Chr(10) & "Status Code:  " & ret
  MsgBox msg, vbOKOnly, ""
  If (vi <> VI_NULL) Then
    ret = age5270_error_message(vi, ret, err_msg)
    msg = "Error:  " & ret & Chr(10) & Chr(10) & err_msg
    MsgBox msg, vbOKOnly, ""
  End If
  End
End If                                                                         '19
 
ret = age5270_reset(vi)                      'Resets E5270.                    '21
ret = age5270_timeOut(vi, 60000)             'Sets time out to 60 sec.
ret = age5270_errorQueryDetect(vi, VI_TRUE)  'Enables error detection.

perform_meas vi, ret                  'Calls perform_meas subprogram.           25
'ret = age5270_cmd(vi, "aa")           'Sends invalid command.
'check_err vi, ret                     'Checks check_err subprogram operation.
 
'Closing the session ********************************************
ret = age5270_close(vi)                                                        '30
check_err vi, ret
 
msg = "Press OK to stop the program."                                          '33
MsgBox msg, vbOKOnly, ""
 
CommandButton1.Caption = "Start Measurement"                                   '36
 
End Sub
Sub perform_meas(vi As Long, ret As Long) '1
Dim pins(3) As Long 'SMU port numbers f3
pins(0) = 1 'SMU1: emitter
pins(1) = 2 'SMU2: base
pins(2) = 4 'SMU4: collector
ret = age5270_setSwitch(vi, pins(2), 1) '8
ret = age5270_setSwitch(vi, pins(1), 1)
ret = age5270_setSwitch(vi, pins(0), 1)
check_err vi, ret '11
mspot_meas vi, ret, pins() '13
ret = age5270_setSwitch(vi, age5270_CH_ALL, 0) '15
check_err vi, ret
End Sub
Sub mspot_meas(vi As Long, ret As Long, pins() As Long) '1
Dim vc As Double '3
Dim vb As Double
Dim ve As Double
Dim iccomp As Double
Dim ibcomp As Double
Dim iecomp As Double
ve = 0
iecomp = 0.2
vb = 0.7
ibcomp = 0.01
vc = 3
iccomp = 1 '15
Dim mch(3) As Long '17
mch(0) = pins(2) 'collector
mch(1) = pins(1) 'base
mch(2) = 0
Dim mode(2) As Long
mode(0) = 1 'current measurement
mode(1) = 1 'current measurement
Dim range(2) As Double
range(0) = 0 'auto range
range(1) = 0 'auto range
Dim md(2) As Double
Dim st(2) As Long
Dim tm(2) As Double '32
CommandButton1.Caption = "Measurement in progress . . ." '34
msg = "Press OK to start measurement. "
MsgBox msg, vbOKOnly, ""
ret = age5270_resetTimestamp(vi) '38
check_err vi, ret
ret = age5270_force(vi, pins(0), age5270_VF_MODE, 0, ve, iecomp, 0)
ret = age5270_force(vi, pins(1), age5270_VF_MODE, 0, vb, ibcomp, 0)
ret = age5270_force(vi, pins(2), age5270_VF_MODE, 0, vc, iccomp, 0)
check_err vi, ret '44
ret = age5270_measureM(vi, mch(0), mode(0), range(0), md(0), st(0), tm(0))
check_err vi, ret '47
ret = age5270_zeroOutput(vi, age5270_CH_ALL)
check_err vi, ret '50
CommandButton1.Caption = "Measurement completed." '52
display_data md(), st(), tm(), vi, ret, pins()
End Sub
Sub display_data(md() As Double, st() As Long, tm() As Double, vi As Long, ret As Long, pins() As Long) '1
Dim title As String '3
Dim value As String
Dim rbx As Integer
title = "Spot Measurement Result" '6
If st(0) = 0 Then '8
value = "Ic = " & md(0) * 1000 & " (mA)"
value = value & Chr(10) & "Time = " & tm(0) & "(sec)"
If st(1) = 0 Then
value = value & Chr(10) & Chr(10) & "Ib = " & md(1) * 1000 & " (mA)"
value = value & Chr(10) & "Time = " & tm(1) & "(sec)"
value = value & Chr(10) & Chr(10) & "hfe = " & md(0) / md(1)
value = value & Chr(10) & Chr(10) & "Do you want to perform measurement again?   "
rbx = MsgBox(value, vbYesNo + vbQuestion, title)
If rbx = vbYes Then
mspot_meas vi, ret, pins()
End If
Else
value = "Base channel status error. Code = " & st(1)
MsgBox value, vbOKOnly, title
End If
Else
value = "Collector channel status error. Code = " & st(0)
MsgBox value, vbOKOnly, title
End If '27
End Sub

Sub check_err(vi As Long, ret As Long)
 Dim inst_err    As Long
 Dim err_message As String * 250
 Dim retStatus   As Long
 If VI_SUCCESS > ret Then
  If (age5270_INSTR_ERROR_DETECTED = ret) Then
    retStatus = age5270_error_query(vi, inst_err, err_message)
    msg = "Instrument Error:  " & inst_err & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  Else
    retStatus = age5270_error_message(vi, ret, err_message)
    msg = "Driver Error:  " & ret & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  End If
 End If
End Sub
