VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Private Sub CommandButton1_Click()                                              '1
 
Dim vi       As Long                                                            '3
Dim ret      As Long
Dim msg      As String
Dim err_msg  As String * 256                                                    '6
 
'Starting the session *******************************************
ret = age5270_init("GPIB::17::INSTR", VI_TRUE, VI_TRUE, vi)                     '9
If ((vi = VI_NULL) Or (ret < VI_SUCCESS)) Then                                 '10
  msg = "Initialization failure." & Chr(10) & Chr(10) & "Status Code:  " & ret
  MsgBox msg, vbOKOnly, ""
  If (vi <> VI_NULL) Then
    ret = age5270_error_message(vi, ret, err_msg)
    msg = "Error:  " & ret & Chr(10) & Chr(10) & err_msg
    MsgBox msg, vbOKOnly, ""
  End If
  End
End If                                                                         '19
 
ret = age5270_reset(vi)                      'Resets E5270.                    '21
ret = age5270_timeOut(vi, 60000)             'Sets time out to 60 sec.
ret = age5270_errorQueryDetect(vi, VI_TRUE)  'Enables error detection.

perform_meas vi, ret                  'Calls perform_meas subprogram.           25
'ret = age5270_cmd(vi, "aa")           'Sends invalid command.
'check_err vi, ret                     'Checks check_err subprogram operation.
 
'Closing the session ********************************************
ret = age5270_close(vi)                                                        '30
check_err vi, ret
 
msg = "Press OK to stop the program."                                          '33
MsgBox msg, vbOKOnly, ""
 
CommandButton1.Caption = "Start Measurement"                                   '36
 
End Sub
Sub perform_meas(vi As Long, ret As Long) '1
Dim m(4) As Long 'SMU port numbers f3
m(0) = 1 'SMU1: drain
m(1) = 2 'SMU2: gate
m(2) = 4 'SMU4: source
m(3) = 6 'SMU6: substrate
ret = age5270_setSwitch(vi, m(3), 1) '9
ret = age5270_setSwitch(vi, m(2), 1)
ret = age5270_setSwitch(vi, m(1), 1)
ret = age5270_setSwitch(vi, m(0), 1)
check_err vi, ret '13
sweep_meas vi, ret, m() '15
ret = age5270_setSwitch(vi, age5270_CH_ALL, 0) '17
check_err vi, ret
End Sub '20
Sub sweep_meas(vi As Long, ret As Long, m() As Long) '1
Dim vd1 As Double '3
Dim vd2 As Double
Dim idcomp As Double
Dim vg1 As Double
Dim vg2 As Double
Dim igcomp As Double
Dim hold As Double
Dim delay As Double
Dim s_delay As Double
Dim p_comp As Double
Dim nop1 As Long
Dim nop2 As Long
vd1 = 0
vd2 = 3
idcomp = 0.05
vg1 = 1
vg2 = 3
igcomp = 0.01
hold = 0
delay = 0
s_delay = 0
p_comp = 0
nop1 = 11
nop2 = 3
Dim i As Integer
Dim j As Integer
Dim n As Long
n = nop1 * nop2 '31
Dim rep As Long '33
Dim sc() As Double 'primary sweep output data
Dim md() As Double 'sweep measurement data
Dim st() As Long 'status data at each step
Dim tm() As Double 'time data at each step
Dim dvg() As Double 'secondary sweep output data
ReDim Preserve sc(n) As Double
ReDim Preserve md(n) As Double
ReDim Preserve st(n) As Long
ReDim Preserve tm(n) As Double
ReDim Preserve dvg(nop2) As Double '43
CommandButton1.Caption = "Measurement in progress . . ." '45
msg = "Press OK to start measurement. "
MsgBox msg, vbOKOnly, ""
ret = age5270_resetTimestamp(vi) '49
check_err vi, ret
ret = age5270_force(vi, m(3), age5270_VF_MODE, 0, 0, 0.05, 0)
ret = age5270_force(vi, m(2), age5270_VF_MODE, 0, 0, 0.05, 0)
Dim d_vg As Double 'secondary sweep step value (delta) f55
If nop2 = 1 Then
d_vg = 0
Else
d_vg = (vg2 - vg1) / (nop2 - 1)
End If '60
Dim vg As Double 'secondary sweep source output f62
vg = vg1
i = 0 'array counter for sweepIv returned data f65
For j = 1 To nop2 'array counter for secondary sweep output data f65
dvg(j - 1) = vg
ret = age5270_force(vi, m(1), age5270_VF_MODE, 0, vg, igcomp, 0)
ret = age5270_setIv(vi, m(0), age5270_SWP_VF_SGLLIN, 0, vd1, vd2, nop1, hold, delay, s_delay, idcomp, p_comp)
check_err vi, ret
ret = age5270_sweepIv(vi, m(0), age5270_IM_MODE, 0, rep, sc(i), md(i), st(i), tm(i))
check_err vi, ret
vg = vg + d_vg
If rep = nop1 Then
i = i + nop1
Else
msg = rep & " measurement steps were returned. It must be " & nop1 & " steps. "
MsgBox msg, vbOKOnly, ""
ret = age5270_zeroOutput(vi, age5270_CH_ALL)
check_err vi, ret
CommandButton1.Caption = "Measurement completed."
GoTo Bottom_sub
End If
Next j '83
ret = age5270_zeroOutput(vi, age5270_CH_ALL) '85
check_err vi, ret
CommandButton1.Caption = "Measurement completed."
save_data nop1, nop2, dvg(), md(), st(), sc(), tm(), vi, ret, m() '89
Bottom_sub:
End Sub '92

Sub save_data(nop1 As Long, nop2 As Long, dvg() As Double, md() As Double, st() As Long, sc() As Double, tm() As Double, vi As Long, ret As Long, m() As Long)
Dim i As Integer 'array counter for primary sweep f3
Dim j As Integer 'array counter for secondary sweep
Dim val As String 'data to be saved to a file
val = "Vg (V), Vd (V), Id (mA), Time (sec), Status"
For j = 1 To nop2 '8
For i = nop1 * (j - 1) To nop1 * j - 1
val = val & Chr(13) & Chr(10) & dvg(j - 1) & "," & sc(i) & "," & md(i) * 1000 & "," & tm(i) & "," & st(i)
Next i
Next j '12
Dim fname As String 'data file name f14
Dim fnum As Integer 'file number
fname = "data1.txt"
fnum = 1
'saves data into the file specified by fname
Open fname For Output Access Write Lock Read Write As fnum
Print #fnum, val
Close fnum '22
'displays data on a MsgBox
Dim title As String
Dim rbx As Integer '25
title = "Sweep Measurement Result"
val = val & Chr(10) & Chr(10) & "Data save completed."
val = val & Chr(10) & Chr(10) & "Do you want to perform measurement again? "
rbx = MsgBox(val, vbYesNo, title)
If rbx = vbYes Then
sweep_meas vi, ret, m() 'returns to sweep_meas if Yes is clicked.
End If '32
End Sub
Sub check_err(vi As Long, ret As Long)
 Dim inst_err    As Long
 Dim err_message As String * 250
 Dim retStatus   As Long
 If VI_SUCCESS > ret Then
  If (age5270_INSTR_ERROR_DETECTED = ret) Then
    retStatus = age5270_error_query(vi, inst_err, err_message)
    msg = "Instrument Error:  " & inst_err & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  Else
    retStatus = age5270_error_message(vi, ret, err_message)
    msg = "Driver Error:  " & ret & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  End If
 End If
End Sub
