VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Private Sub CommandButton1_Click()                                              '1
 
Dim vi       As Long                                                            '3
Dim ret      As Long
Dim msg      As String
Dim err_msg  As String * 256                                                    '6
 
'Starting the session *******************************************
ret = age5270_init("GPIB::17::INSTR", VI_TRUE, VI_TRUE, vi)                     '9
If ((vi = VI_NULL) Or (ret < VI_SUCCESS)) Then                                 '10
  msg = "Initialization failure." & Chr(10) & Chr(10) & "Status Code:  " & ret
  MsgBox msg, vbOKOnly, ""
  If (vi <> VI_NULL) Then
    ret = age5270_error_message(vi, ret, err_msg)
    msg = "Error:  " & ret & Chr(10) & Chr(10) & err_msg
    MsgBox msg, vbOKOnly, ""
  End If
  End
End If                                                                         '19
 
ret = age5270_reset(vi)                      'Resets E5270.                    '21
ret = age5270_timeOut(vi, 60000)             'Sets time out to 60 sec.
ret = age5270_errorQueryDetect(vi, VI_TRUE)  'Enables error detection.

perform_meas vi, ret                  'Calls perform_meas subprogram.           25
'ret = age5270_cmd(vi, "aa")           'Sends invalid command.
'check_err vi, ret                     'Checks check_err subprogram operation.
 
'Closing the session ********************************************
ret = age5270_close(vi)                                                        '30
check_err vi, ret
 
msg = "Press OK to stop the program."                                          '33
MsgBox msg, vbOKOnly, ""
 
CommandButton1.Caption = "Start Measurement"                                   '36
 
End Sub
Sub perform_meas(vi As Long, ret As Long) '1
Dim m(3) As Long 'SMU port numbers f3
m(0) = 4 'SMU1: collector
m(1) = 2 'SMU2: base
m(2) = 1 'SMU4: emitter
ret = age5270_setSwitch(vi, m(2), 1) '8
ret = age5270_setSwitch(vi, m(1), 1)
ret = age5270_setSwitch(vi, m(0), 1)
check_err vi, ret '11
sweep_meas vi, ret, m() '13
ret = age5270_setSwitch(vi, age5270_CH_ALL, 0) '15
check_err vi, ret
End Sub '18
Sub sweep_meas(vi As Long, ret As Long, m() As Long) '1
Dim vc1 As Double '3
Dim vc2 As Double
Dim iccomp As Double
Dim ib1 As Double
Dim ib2 As Double
Dim vbcomp As Double
Dim hold As Double
Dim width As Double
Dim period As Double
Dim base As Double
Dim smpl As Double
Dim nop1 As Long
Dim nop2 As Long
vc1 = 0
vc2 = 3
iccomp = 0.05
ib1 = 0.00005 ' 50 uA
ib2 = 0.00015 '150 uA
vbcomp = 5
hold = 0.1
width = 0.001
period = 0.01
base = 0
smpl = 5
nop1 = 11
nop2 = 3
Dim i As Integer
Dim j As Integer
Dim n As Long
n = nop1 * nop2 '33
Dim rep As Long '35
Dim sc() As Double 'primary sweep output data
Dim md() As Double 'sweep measurement data
Dim st() As Long 'status data at each step
Dim tm() As Double 'time data at each step
Dim dib() As Double 'secondary sweep output data
ReDim Preserve sc(n) As Double
ReDim Preserve md(n) As Double
ReDim Preserve st(n) As Long
ReDim Preserve tm(n) As Double
ReDim Preserve dib(nop2) As Double '45
CommandButton1.Caption = "Measurement in progress . . ." '47
msg = "Press OK to start measurement. "
MsgBox msg, vbOKOnly, ""
ret = age5270_setAdc(vi, age5270_HSPEED_ADC, age5270_INTEG_MANUAL, smpl, age5270_FLAG_OFF) '51
ret = age5270_setAdcType(vi, age5270_CH_ALL, age5270_HSPEED_ADC)
ret = age5270_resetTimestamp(vi)
check_err vi, ret '54
ret = age5270_force(vi, m(2), age5270_VF_MODE, 0, 0, 0.05, 0)
Dim d_ib As Double 'secondary sweep step value (delta) f58
If nop2 = 1 Then
d_ib = 0
Else
d_ib = (ib2 - ib1) / (nop2 - 1)
End If '63
Dim ibo As Double 'secondary sweep source output f65
ibo = ib1
i = 0 'array counter for sweepIv returned data
For j = 1 To nop2 '70
dib(j - 1) = ibo
ret = age5270_force(vi, m(1), age5270_IF_MODE, 0, ibo, vbcomp, 0)
ret = age5270_setPiv(vi, m(0), age5270_SWP_VF_SGLLIN, 0, base, vc1, vc2, nop1, hold, width, period, iccomp)
check_err vi, ret
ret = age5270_sweepPiv(vi, m(0), age5270_IM_MODE, 0, rep, sc(i), md(i), st(i), tm(i))
check_err vi, ret
ibo = ibo + d_ib
If rep = nop1 Then '78
i = i + nop1
Else
msg = rep & " measurement steps were returned. It must be " & nop1 & " steps."

MsgBox msg, vbOKOnly, ""
ret = age5270_zeroOutput(vi, age5270_CH_ALL)
check_err vi, ret
CommandButton1.Caption = "Measurement completed."
GoTo Bottom_sub
End If '87
Next j '88
ret = age5270_zeroOutput(vi, age5270_CH_ALL) '90
check_err vi, ret
CommandButton1.Caption = "Measurement completed." '93
save_data nop1, nop2, md(), st(), sc(), tm(), dib(), vi, ret, m() '95
Bottom_sub:
End Sub '98
Sub save_data(nop1 As Long, nop2 As Long, md() As Double, st() As Long, sc() As Double, tm() As Double, dib() As Double, vi As Long, ret As Long, m() As Long) '1
Dim i As Integer 'array counter for sweepPiv returned data f3
Dim j As Integer 'array counter for secondary sweep output data
Dim val As String 'data to be saved to a file
val = "Ib (uA), Vc (V), Ic (mA), Time (sec), Status"
For j = 1 To nop2 '9
For i = nop1 * (j - 1) To nop1 * j - 1
val = val & Chr(13) & Chr(10) & dib(j - 1) * 1000000# & "," & sc(i) & "," & md(i) * 1000 & "," & tm(i) & "," & st(i)
Next i
Next j '14
Dim fname As String 'data file name f16
Dim fnum As Integer 'file number
fname = "data1.txt"
fnum = 1
Open fname For Output Access Write Lock Read Write As fnum
Print #fnum, val
Close fnum
Dim title As String
Dim rbx As Integer '24
title = "Pulsed Sweep Measurement Result"
val = val & Chr(10) & Chr(10) & "Data save completed."
val = val & Chr(10) & Chr(10) & "Do you want to perform measurement again? "
rbx = MsgBox(val, vbYesNo, title)
If rbx = vbYes Then
sweep_meas vi, ret, m() 'returns to sweep_meas if Yes is clicked.
End If
End Sub '33

Sub check_err(vi As Long, ret As Long)
 Dim inst_err    As Long
 Dim err_message As String * 250
 Dim retStatus   As Long
 If VI_SUCCESS > ret Then
  If (age5270_INSTR_ERROR_DETECTED = ret) Then
    retStatus = age5270_error_query(vi, inst_err, err_message)
    msg = "Instrument Error:  " & inst_err & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  Else
    retStatus = age5270_error_message(vi, ret, err_message)
    msg = "Driver Error:  " & ret & Chr(10) & Chr(10) & err_message
    MsgBox msg, vbOKOnly, ""
  End If
 End If
End Sub
