Imports Ivi.visa.interop

Module Module1

    Sub Main()

        Dim B1500 As IResourceManager
        Dim session As IMessage
        B1500 = New ResourceManager
        session = B1500.Open("GPIB0::17::INSTR")
        session.WriteString("*RST" & vbLf)

        Dim fmt As Integer = 1 : session.WriteString("FMT" & fmt & vbLf)
        Dim t() As Integer = {4, 3, 2, 1}  'Drain, Gate, Source, Sub

        session.WriteString("VAR0,0," & t(0) & vbLf) '%I0=t(0)
        session.WriteString("VAR0,1," & t(1) & vbLf) '%I1=t(1)
        session.WriteString("VAR0,2," & t(2) & vbLf) '%I2=t(2)
        session.WriteString("VAR0,3," & t(3) & vbLf) '%I3=t(3)
        session.WriteString("VAR0,4,0" & vbLf)       '%I4=mrng
        session.WriteString("VAR0,5,0" & vbLf)       '%I5=orng
        session.WriteString("VAR1,0,1" & vbLf)       '%R0=vd
        session.WriteString("VAR1,1,0.8" & vbLf)     '%R1=vg
        session.WriteString("VAR1,2,0.1" & vbLf)     '%R2=idcomp
        session.WriteString("VAR1,3,0.05" & vbLf)    '%R3=igcomp
        session.WriteString("VAR1,4,0" & vbLf)       '%R4=v0
        session.WriteString("VAR1,5,0.1" & vbLf)     '%R5=hold
        session.WriteString("VAR1,6,0.01" & vbLf)    '%R6=width
        session.WriteString("VAR1,7,0.02" & vbLf)    '%R7=period

        Dim mem As Integer = 1
        session.WriteString("ST" & mem & vbLf)
        session.WriteString("DV %I3,0,0,0.1" & vbLf)
        session.WriteString("DV %I2,0,0,0.1" & vbLf)
        session.WriteString("DV %I1,%I5,%R1,%R3" & vbLf)
        session.WriteString("DV %I0,%I5,%R0,%R2" & vbLf)
        session.WriteString("TI %I0,%I4" & vbLf)
        session.WriteString("END" & vbLf)
        display_mem(session, mem)

        mem = 2
        session.WriteString("ST" & mem & vbLf)
        session.WriteString("PT %R5,%R6,%R7" & vbLf)
        session.WriteString("DV %I3,0,0,0.1" & vbLf)
        session.WriteString("DV %I2,0,0,0.1" & vbLf)
        session.WriteString("PV %I1,%I5,%R4,%R1,%R3" & vbLf)
        session.WriteString("DV %I0,%I5,%R0,%R2" & vbLf)
        session.WriteString("MM3,%I0" & vbLf)
        session.WriteString("RI %I0,%I4" & vbLf)
        session.WriteString("XE" & vbLf)
        session.WriteString("END" & vbLf)
        display_mem(session, mem)

        Dim term As String = t(0) & "," & t(1) & "," & t(2) & "," & t(3)
        session.WriteString("CN" & term & vbLf)
        Dim i As Integer : Dim ret As Integer : Dim msg As String
        Dim value As String : Dim status As String : Dim meas As Double
        For i = 1 To 2
            session.WriteString("DO" & i & vbLf)
            session.WriteString("*OPC?" & vbLf) : ret = session.ReadString(1 + 2)
            session.WriteString("ERR? 1" & vbLf) : ret = session.ReadString(4 + 2)
            If ret <> 0 Then session.WriteString("DZ" & vbLf) : GoTo Check_err
            value = session.ReadString(17) : status = Left(value, 3)
            value = Mid(value, 4, 12) : meas = Val(value)
            Console.WriteLine("Memory " & i & ": Id = " & meas & " (A), Status = " & status & Chr(10))
        Next
        session.WriteString("VAR1,0,3" & vbLf)      '%R0=vd
        For i = 1 To 2
            session.WriteString("DO" & i & vbLf)
            session.WriteString("*OPC?" & vbLf) : ret = session.ReadString(1 + 2)
            session.WriteString("ERR? 1" & vbLf) : ret = session.ReadString(4 + 2)
            If ret <> 0 Then session.WriteString("DZ" & vbLf) : GoTo Check_err
            value = session.ReadString(17) : status = Left(value, 3)
            value = Mid(value, 4, 12) : meas = Val(value)
            Console.WriteLine("Memory " & i & ": Id = " & meas & " (A), Status = " & status & Chr(10))
        Next
        session.WriteString("DZ" & vbLf)
        session.WriteString("CL" & vbLf)
        session.Close()
        MsgBox("Completed", vbOKOnly, "")
        Exit Sub

Check_err:
        session.WriteString("EMG? " & ret & vbLf) : msg = session.ReadString(256)
        MsgBox("Instrument error: " & ret & Chr(10) & msg, vbOKOnly, "")
        Exit Sub
    End Sub

    Sub display_mem(ByVal session As IMessage, ByVal mem As Integer)
        session.WriteString("LST?" & mem & vbLf)
        Dim prog_list As String = session.ReadString(256)
        Console.WriteLine("Memory " & mem & ":")
        Console.WriteLine(prog_list & Chr(10))
    End Sub


End Module
