Imports Ivi.visa.interop

Module Module1


    Sub Main()
        Dim B1500 As IResourceManager
        Dim session As IMessage
        B1500 = New ResourceManager
        session = B1500.Open("GPIB0::17::INSTR")
        session.WriteString("*RST" & vbLf)
        MsgBox("Click OK to start measurement.", vbOKOnly, "")
        Console.WriteLine("Measurement in progress. . ." & Chr(10))

        Dim t() As Integer = {4, 3, 2, 1}
        Dim term As String = t(0) & "," & t(1) & "," & t(2) & "," & t(3)
        session.WriteString("CN " & term & vbLf)
        perform_meas(session, t)

        session.WriteString("CL" & vbLf)
        session.Close()
        MsgBox("Click OK to stop the program.", vbOKOnly, "")
        Console.WriteLine("Measurement completed." & Chr(10))
    End Sub

    Sub perform_meas(ByVal session As IMessage, ByVal t() As Integer)
        Dim i As Integer = 0                         't(0): Emitter
        Dim j As Integer = 0                         't(1): Base
        Dim nop1 As Integer = 1                      't(2): Collector
        Dim nop2 As Integer = 1                      't(3): not use
        Dim data(nop2-1, nop1-1) As String
        Dim value As String = "BVceo (V), Status"
        Dim fname As String = "C:\Agilent\prog_ex\data8.txt"
        Dim title As String = "Measurement Result"
        Dim msg As String = "No error."
        Dim err As Integer = 0

        Dim vc1 As Double = 0
        Dim vc2 As Double = 100
        Dim iccomp As Double = 0.005
        Dim hold As Double = 0
        Dim delay As Double = 0
        Dim interval As Double = 0
        Dim mmode As Double = 0
        Dim mrng As Integer = 0
        session.WriteString("FMT 1" & vbLf)
        session.WriteString("CL " & t(1) & "," & t(3) & vbLf)
        session.WriteString("MM 9," & t(2) & vbLf)              '9: quasi pulsed spot
        session.WriteString("BDT " & hold & "," & delay & vbLf)
        session.WriteString("BDM " & interval & "," & mmode & vbLf)
        session.WriteString("BDV " & t(2) & "," & mrng & "," & vc1 & "," & vc2 & "," & iccomp & vbLf)
        session.WriteString("ERR? 1" & vbLf) : err = session.ReadString(4 + 2)
        If err <> 0 Then session.WriteString("DZ" & vbLf) : GoTo Check_err
        session.WriteString("DV " & t(0) & ",0,0,0.1" & vbLf)   'out= 0 V, comp= 0.1 A
        session.WriteString("XE" & vbLf)

        Dim data1 As String = session.ReadString(17)
        Dim status As String = Left(data1, 3)
        data1 = Mid(data1, 4, 12)
        Dim meas As Double = Val(data1)

        data(j, i) = Chr(13) & Chr(10) & meas & ", " & status

        session.WriteString("DZ" & vbLf)
        save_data(fname, title, value, data, nop1, nop2, session, t)
        Exit Sub

Check_err:
        session.WriteString("EMG? " & err & vbLf) : msg = session.ReadString(256)
        MsgBox("Instrument error: " & err & Chr(10) & msg, vbOKOnly, "")
    End Sub


    Sub save_data(ByVal fname As String, ByVal title As String, ByVal value As String, ByVal data(,) As String, ByVal nop1 As Integer, ByVal nop2 As Integer, ByVal session As IMessage, ByVal t() As Integer)
        Dim i As Integer = 0
        Dim j As Integer = 0
        FileOpen(1, fname, OpenMode.Output, OpenAccess.Write, OpenShare.LockReadWrite)
        Print(1, value)
        For j = 0 To nop2 - 1
            For i = 0 To nop1 - 1
                Print(1, data(j, i))
            Next
        Next
        FileClose(1)

        Dim rbx As Integer
        For j = 0 To nop2 - 1
            For i = 0 To nop1 - 1
                value = value & data(j, i)
            Next
        Next
        value = value & Chr(10) & Chr(10) & "Data save completed."
        value = value & Chr(10) & Chr(10) & "Do you want to perform measurement again?"
        rbx = MsgBox(value, vbYesNo, title)
        If rbx = vbYes Then perform_meas(session, t)
    End Sub

End Module
