#include <stdio.h>
#include "E5270_TIS.h"

main()
{
int ret;

#ifdef E5270_TIS_H
	ret = open_E5270( "GPIB0::17::INSTR" , ERR_DETECT_ON,NULL );
	if ( ret != 0 ) {
					printf( "Failed to open E5270. Exit program.\n" );
					return( -1 );
					}
#endif

int drain, gate, source, sub, nop, samples, n = 1, port[1], status[11];
double vrange1, vrange2, vd, hold, delay, icomp, ig_c, d_p_c, g_p_c;
double irange, id[11], swp1[11], swp2[11], time[11];

vrange1 = 2.0;
vrange2 = 20.0;
irange = 0.0;
vd = 2.5;
nop = 11;
hold = 0.1;
delay = 0.0;
ig_c = 1e-3;
icomp = 50e-3;
d_p_c = 0.1;
g_p_c = 0.002;

drain = 15;
gate = 16;
source = 17;
sub = 18;
samples = 100;

init_system();
connect_pin(SMU1, drain);
connect_pin(SMU2, gate);
connect_pin(SMU4, source);
connect_pin(SMU6, sub);

port[0] = drain;

set_timestamp(1);
set_smu_ch(0, PERCH_ADC, FILTER_OFF);
set_adc(PERCH_ADC, INTEG_MANUAL, samples, 0);

force_v(source, 0.0, vrange1, icomp);
reset_timestamp();
force_v(sub, 0.0, vrange1, icomp);
set_iv(drain, LINEAR_V, vrange2, 0.0, vd, nop, hold, delay, icomp, d_p_c, COMP_STOP);
set_sync(gate, POS_SYNC, 0.0, 1.0, ig_c, g_p_c);
sweep_iv(drain, I_MEAS, irange, id, swp1, swp2);
status_miv(n, port, status, time);

disable_port(0);
disconnect_all();

int i;

printf(" Vg (V)  Id (mA)  Status  Time (s)\n");
for (i=0; i<nop;i++)
printf(" %3.2f    %6.4f  %d  %6.4f\n", swp2[i], id[i] * 1000, status[i], time[i]);

#ifdef E5270_TIS_H
	close_E5270();
#endif
	return( 0 );
}