#include <stdio.h>
#include "E5270_TIS.h"

main()
{
int ret;

#ifdef E5270_TIS_H
	ret = open_E5270( "GPIB0::17::INSTR" , ERR_DETECT_ON,NULL );
	if ( ret != 0 ) {
					printf( "Failed to open E5270. Exit program.\n" );
					return( -1 );
					}
#endif

int drain, gate, source, sub, nop;
double vrange1, vrange2, vd, vg, width, period, hold, delay, icomp, ig_c, pcomp;
double irange, id[11], swp1[11], swp2[11];

vrange1 = 2.0;
vrange2 = 20.0;
irange = 0.0;
vd = 2.5;
vg = 3.0;
nop = 11;
width = 0.001;
period = 0.01;
hold = 0.1;
delay = 0.0;
ig_c = 1e-6;
icomp = 50e-3;
pcomp = 0.07;

drain = 15;
gate = 16;
source = 17;
sub = 18;

init_system();
connect_pin(SMU1, drain);
connect_pin(SMU2, gate);
connect_pin(SMU4, source);
connect_pin(SMU6, sub);

force_v(source, 0.0, vrange1, icomp);
force_v(sub, 0.0, vrange1, icomp);
set_iv(drain, LINEAR_V, vrange2, 0.0, vd, nop, hold, delay, icomp, pcomp, COMP_STOP);
set_pbias(gate, V_SOURCE, vrange2, 0.0, vg, width, period, hold, ig_c);
sweep_iv(drain, I_MEAS, irange, id, swp1, swp2);

disable_port(0);
disconnect_all();

int i;

printf(" Vd (V)  Id (mA)\n");
for (i=0; i<nop;i++)
printf(" %3.2f    %8.6f \n", swp1[i], id[i] * 1000);

#ifdef E5270_TIS_H
	close_E5270();
#endif
	return( 0 );
}